//+------------------------------------------------------------------+
//|                                                        Bands.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
#property indicator_separate_window
//#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 LightSeaGreen
#property indicator_color3 LightSeaGreen
//---- indicator parameters
extern int    BandsPeriod=6;
extern int    BandsShift=0;
extern double BandsDeviations=2.0;
//---- buffers
double B1[],PR[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,EMPTY, 1, Red);
   SetIndexBuffer(0,B1);
   SetIndexStyle(1,DRAW_LINE,EMPTY, 1, LightSeaGreen);
   SetIndexBuffer(1,PR);
//   SetIndexStyle(2,DRAW_LINE);
//   SetIndexBuffer(2,LowerBuffer);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,tt,counted_bars=IndicatorCounted();
   double deviation,BBTop,BBBot;
    i=Bars-BandsPeriod+1;
while(i>=0)
     {
     BBTop = iBands(NULL,0,BandsPeriod,BandsDeviations,0,PRICE_MEDIAN,MODE_LOWER,i);//BollingerBand(Price, Length, StdDevUp);
     BBBot = iBands(NULL,0,BandsPeriod,BandsDeviations,0,PRICE_MEDIAN,MODE_UPPER,i);//BollingerBand(Price, Length, StdDevDn);
     B1[i]=BBBot-BBTop;
     PR[i] =Close[i]-iSAR(NULL,0,0.02,0.2,i);
     i--;
        }
        
//----
   return(0);
  }
//+------------------------------------------------------------------+